export function getEntityAction(entityName) {
    var SELECTED_ENTITY = entityName + '/selected';
    var LOAD = entityName + '/load';
    var LOAD_SUCCESS = entityName + '/load/success';
    var LOAD_ERROR = entityName + '/load/error';
    var ADD = entityName + '/add';
    var ADD_SUCCESS = entityName + '/add/success';
    var ADD_ERROR = entityName + '/add/error';
    var EDIT = entityName + '/edit';
    var EDIT_SUCCESS = entityName + '/edit/success';
    var EDIT_ERROR = entityName + '/edit/error';
    var DELETE = entityName + '/delete';
    var DELETE_SUCCESS = entityName + '/delete/success';
    var DELETE_ERROR = entityName + '/delete/error';
    var SELECT = entityName + '/select';
    // DELETE
    // class LoadAction implements Action {
    //   readonly type = LOAD;
    //   constructor() {}
    // }
    function getSetSelectedEntityAction(selectedEntityId) {
        return {
            type: SELECTED_ENTITY,
            payload: selectedEntityId
        };
    }
    function getLoadAction() {
        return {
            entityName: entityName,
            type: LOAD
        };
    }
    function getLoadSuccessAction(payload) {
        return {
            entityName: entityName,
            type: LOAD_SUCCESS,
            payload: payload
        };
    }
    function getLoadErrorAction(payload) {
        return {
            entityName: entityName,
            type: LOAD_ERROR,
            payload: payload
        };
    }
    function getAddAction(payload) {
        return {
            entityName: entityName,
            type: ADD,
            payload: payload
        };
    }
    function getAddSuccessAction(payload) {
        return {
            entityName: entityName,
            type: ADD_SUCCESS,
            payload: payload
        };
    }
    function getAddErrorAction(payload) {
        return {
            entityName: entityName,
            type: ADD_ERROR,
            payload: payload
        };
    }
    function getEditAction(payload) {
        return {
            entityName: entityName,
            type: EDIT,
            payload: payload
        };
    }
    function getEditSuccessAction(payload) {
        return {
            entityName: entityName,
            type: EDIT_SUCCESS,
            payload: payload
        };
    }
    function getEditErrorAction(payload) {
        return {
            entityName: entityName,
            type: EDIT_ERROR,
            payload: payload
        };
    }
    function getDeleteAction(payload) {
        return {
            entityName: entityName,
            type: DELETE,
            payload: payload
        };
    }
    function getDeleteSuccessAction(payload) {
        return {
            entityName: entityName,
            type: DELETE_SUCCESS,
            payload: payload
        };
    }
    function getDeleteErrorAction(payload) {
        return {
            entityName: entityName,
            type: DELETE_ERROR,
            payload: payload
        };
    }
    // class SelectAction implements Action {
    //   readonly type = SELECT;
    //   constructor(public payload: string | number) {}
    // }
    // class EditAction implements Action {
    //   readonly type = EDIT;
    //   constructor(public payload: T) {}
    // }
    // class DeleteAction implements Action {
    //   readonly type = DELETE;
    //   constructor(public payload: T) {}
    // }
    // type Actions =
    //   | LoadAction
    //   | AddAction
    //   | EditAction
    //   | SelectAction
    //   | DeleteAction
    //   | AddSuccessAction
    //   | LoadSuccessAction;
    return {
        SELECTED_ENTITY: SELECTED_ENTITY,
        LOAD: LOAD,
        LOAD_SUCCESS: LOAD_SUCCESS,
        LOAD_ERROR: LOAD_ERROR,
        ADD: ADD,
        ADD_SUCCESS: ADD_SUCCESS,
        ADD_ERROR: ADD_ERROR,
        EDIT: EDIT,
        EDIT_SUCCESS: EDIT_SUCCESS,
        EDIT_ERROR: EDIT_ERROR,
        SELECT: SELECT,
        DELETE: DELETE,
        DELETE_SUCCESS: DELETE_SUCCESS,
        DELETE_ERROR: DELETE_ERROR,
        getSetSelectedEntityAction: getSetSelectedEntityAction,
        getAddAction: getAddAction,
        getAddSuccessAction: getAddSuccessAction,
        getAddErrorAction: getAddErrorAction,
        getLoadAction: getLoadAction,
        getLoadSuccessAction: getLoadSuccessAction,
        getLoadErrorAction: getLoadErrorAction,
        getEditAction: getEditAction,
        getEditSuccessAction: getEditSuccessAction,
        getEditErrorAction: getEditErrorAction,
        getDeleteAction: getDeleteAction,
        getDeleteSuccessAction: getDeleteSuccessAction,
        getDeleteErrorAction: getDeleteErrorAction
        // EditAction,
        // DeleteAction,
        // SelectAction,
    };
}
//# sourceMappingURL=actions.js.map