import { Actions } from '@ngrx/effects';
import 'rxjs/add/operator/switchMap';
import 'rxjs/add/operator/mergeMap';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/filter';
import 'rxjs/add/observable/empty';
import 'rxjs/add/observable/of';
import 'rxjs/add/operator/take';
import 'rxjs/add/operator/do';
import 'rxjs/add/operator/catch';
import { EntityService, StoreModel } from '.';
import { Observable } from 'rxjs/Observable';
export declare class EntityEffects<T extends StoreModel> {
    private _actions$;
    private _entityService;
    loadEntities: Observable<{
        type: string;
    }>;
    addEntities: Observable<{
        type: string;
    }>;
    editEntity: Observable<{}>;
    deleteEntity: Observable<{}>;
    constructor(_actions$: Actions, _entityService: EntityService);
}
