import { StoreModule } from '@ngrx/store';
import { NgModule, InjectionToken } from '@angular/core';
import { CommonModule } from '@angular/common';
import { getReducerr } from '.';
export var tenantReducerToken = new InjectionToken('Tenant Registered Reducers');
export var entities = new InjectionToken('ENTITIES');
var StoreGeneratorModule = (function () {
    function StoreGeneratorModule() {
    }
    StoreGeneratorModule.forRoot = function (getEntities) {
        return {
            ngModule: StoreGeneratorModule,
            providers: [
                {
                    provide: entities,
                    useFactory: getEntities
                },
                {
                    provide: tenantReducerToken,
                    deps: [entities],
                    useFactory: getReducerr
                }
            ]
        };
    };
    StoreGeneratorModule.decorators = [
        { type: NgModule, args: [{
                    // declarations: [HelloWorldComponent],
                    imports: [CommonModule, StoreModule.forFeature('entity', tenantReducerToken)]
                    // exports: [HelloWorldComponent],
                    // providers: [EntityService],
                },] },
    ];
    /** @nocollapse */
    StoreGeneratorModule.ctorParameters = function () { return []; };
    return StoreGeneratorModule;
}());
export { StoreGeneratorModule };
//# sourceMappingURL=store-generator.module.js.map